<template>
  <article class="view view--gallery-album-edit">
    <LoadingSpinner v-if="loading" />
    <VForm
      v-if="loaded"
      name="album-form"
      :fields="fields"
      :modelState="modelState"
      :buttonText="saveText"
      buttonIconClass="bi bi-save-fill"
      :busy="saving"
      :busyButtonText="`${savingText}...`"
      @submit="onSubmit"
    />
  </article>
</template>

<script>
import { ref, computed, onMounted, onUpdated } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, VForm, useApi, useNotification, useVForm } from '../../../core'
import { useAuth } from '../../../identity'
import AlbumsApi from '../../api/albums-api.js'

export default {
  name: 'GalleryAlbumEditView',
  components: {
    LoadingSpinner,
    VForm,
  },
  setup() {
    const route = useRoute()
    const router = useRouter()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const vform = useVForm()
    const notify = useNotification()
    const albumsApi = new AlbumsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const album = ref(undefined)
    const modelState = ref({})
    const saving = ref(false)
    const fields = ref([
      {
        type: 'text',
        name: 'displayName',
        label: 'Display name',
        maxlength: 200,
        validate: 'required',
        value: '',
      },
      {
        type: 'text',
        name: 'description',
        label: 'Description',
        maxlength: 200,
        value: '',
      },
    ])

    const alias = computed(() => {
      return ValidationHelper.getString(route.params.alias, '')
    })

    const selecting = computed(() => {
      return ValidationHelper.getBoolean(route.query.selecting, false) && Boolean(store.state.gallery.formName)
    })

    const mode = computed(() => {
      return alias.value ? 'Edit' : 'Create'
    })

    const title = computed(() => {
      return `${mode.value} album`
    })

    const albumDisplayName = computed(() => {
      return album.value ? album.value.displayName : alias.value
    })

    const breadcrumbs = computed(() => {
      const breadcrumbs = [
        {
          text: 'Users',
          route: { name: 'identity-users' },
        },
        {
          text: store.state.identity.session.username,
          route: store.state.identity.session.username
            ? { name: 'identity-user-profile', params: { username: store.state.identity.session.username } }
            : null,
        },
        {
          text: `Gallery`,
          route: store.state.identity.session.username
            ? { name: 'gallery-albums', params: { username: store.state.identity.session.username } }
            : null,
        },
      ]

      if (store.state.identity.session.username && alias.value) {
        breadcrumbs.push({
          text: albumDisplayName.value,
          route: {
            name: 'gallery-images',
            params: { username: store.state.identity.session.username, alias: alias.value },
          },
        })
        breadcrumbs.push({
          text: mode.value,
          route: null, // No link to self
        })
      } else {
        breadcrumbs.push({
          text: title.value,
          route: null, // No link to self
        })
      }

      return breadcrumbs
    })

    const saveText = computed(() => {
      return album.value ? 'Update' : 'Create'
    })

    const savingText = computed(() => {
      return album.value ? 'Updating' : 'Creating'
    })

    const savedText = computed(() => {
      return album.value ? 'Updated' : 'Created'
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      album.value = null

      try {
        // We're using 'fetch' so that we can get the album by it's username and alias, rather than it's id.
        const response = await albumsApi.fetchAsync({
          username: store.state.identity.session.username,
          alias: alias.value,
          expand: 'all',
        })

        // We should only get one result.
        album.value = response.data[0]
        const form = {
          displayName: response.data[0].displayName,
          description: response.data[0].description,
        }
        fields.value = vform.set(fields.value, form)
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the album.', ex)
      } finally {
        loading.value = false
      }
    }

    const onSubmit = async (form) => {
      saving.value = true

      try {
        if (album.value) {
          await albumsApi.updateAsync(album.value.id, form)
        } else {
          await albumsApi.createAsync(form)
        }
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error(`There was a problem ${savingText.value.toLowerCase()} the album.`, ex)
        }
        return
      } finally {
        saving.value = false
      }

      notify.success(`Album ${savedText.value.toLowerCase()} successfully.`)
      router.push({
        name: 'gallery-albums',
        params: { username: store.state.identity.session.username },
        query: { selecting: selecting.value ? 'true' : undefined },
      })
    }

    onMounted(async () => {
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)

      if (alias.value) {
        await loadAsync()
      } else {
        loaded.value = true // creating
      }
    })

    onUpdated(() => {
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
    })

    return {
      loading,
      loaded,
      album,
      modelState,
      saving,
      fields,
      alias,
      selecting,
      mode,
      title,
      albumDisplayName,
      breadcrumbs,
      saveText,
      savingText,
      savedText,
      onSubmit,
    }
  },
}
</script>
